unit Main; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  BaseUnix, Unix;

type

  { TForm1 }

  TForm1 = class(TForm)
    teBrightness: TEdit;
    sbDimmer: TScrollBar;
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure sbDimmerChange(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

const
   CAPE_MANAGER_SLOT_FILE_NAME: PChar = '/sys/devices/bone_capemgr.9/slots';
   PWM_MODULE : PChar = 'am33xx_pwm';
   PWM_PIN : PChar = 'bone_pwm_P8_13';

   PWM_PERIOD_FILENAME : PChar = '/sys/devices/ocp.3/pwm_test_P8_13.15/period';
   PWM_DUTY_FILENAME : PChar = '/sys/devices/ocp.3/pwm_test_P8_13.15/duty';

   PWM_PERIOD: PCHar = '1000000';  // Set period : 1ms
var
  Form1: TForm1;
  returnCode: longint; // stores the result of the IO operation

  dutyFileDesc : integer;
implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormActivate(Sender: TObject);
var
   fileDesc : integer;

begin
   // Prepare PWM module
   try
     fileDesc := fpopen(CAPE_MANAGER_SLOT_FILE_NAME, O_WRONLY);
     returnCode := fpwrite(fileDesc, PWM_MODULE[0], StrLen(PWM_MODULE));

     // Add P8_13 pin as a PWM module
     returnCode := fpwrite(fileDesc, PWM_PIN[0], StrLen(PWM_PIN));

   finally
     returnCode := fpclose(fileDesc);
   end;

   // Set PWM period as 1ms
   try
     fileDesc := fpopen(PWM_PERIOD_FILENAME, O_WRONLY);
     returnCode := fpwrite(fileDesc, PWM_PERIOD[0], StrLen(PWM_PERIOD));
   finally
     returnCode := fpclose(fileDesc);
   end;

   sbDimmer.Position:= 60;
end;

procedure TForm1.sbDimmerChange(Sender: TObject);
var
  fileDesc : integer;
  intDuty : LongInt;
  strDuty : String;
begin
   intDuty := sbDimmer.Position;
   strDuty := IntToStr((100-intDuty+1) * 10000); // convert 1-100 value as 10_000 - 1000_000

   teBrightness.Text := IntToStr(intDuty);

   // Set PWM period as 1ms
   try
     fileDesc := fpopen(PWM_DUTY_FILENAME, O_WRONLY);
     returnCode := fpwrite(fileDesc, PChar(strDuty)[0], Length(strDuty));
   finally
     returnCode := fpclose(fileDesc);
   end;
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin

end;
end.

